com.fasterxml.jackson.databind.deser.std

## Class EnumDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer<Object>
      - - com.fasterxml.jackson.databind.deser.std.EnumDeserializer

- All Implemented Interfaces:
    Serializable

      public class EnumDeserializer
      extends StdScalarDeserializer<Object>

  Deserializer class that can deserialize instances of specified Enum class from Strings and Integers.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `EnumDeserializer.FactoryBasedDeserializer` Deserializer that uses a single-String static factory method for locating Enum values by String id.

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected CompactStringObjectMap` | `_enumLookup`
    `protected Object[]` | `_enumsByIndex`

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_valueClass, F_MASK_INT_COERCIONS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EnumDeserializer(EnumResolver res)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected Object` | `_deserializeOther(JsonParser p, DeserializationContext ctxt)`
    `protected Class<?>` | `_enumClass()`
    `protected void` | `_failOnNumber(DeserializationContext ctxt, JsonParser p, int index)`
    `Object` | `deserialize(JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `static JsonDeserializer<?>` | `deserializerForCreator(DeserializationConfig config, Class<?> enumClass, AnnotatedMethod factory)` Factory method used when Enum instances are to be deserialized using a creator (static factory method)
    `boolean` | `isCachable()` Because of costs associated with constructing Enum resolvers, let's cache instances by default.

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdScalarDeserializer

      `deserializeWithType`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_coerceIntegral, _deserializeFromEmpty, _failDoubleToIntCoercion, _hasTextualNull, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _parseBoolean, _parseBooleanFromOther, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, _parseString, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, getValueClass, getValueType, handledType, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `deserialize, findBackReference, getDelegatee, getEmptyValue, getEmptyValue, getKnownPropertyNames, getNullValue, getNullValue, getObjectIdReader, replaceDelegatee, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _enumLookup

          protected final CompactStringObjectMap _enumLookup

      Since:
        2.6

    - #### _enumsByIndex

          protected Object[] _enumsByIndex

      Since:
        2.6

  - ### Constructor Detail

    - #### EnumDeserializer

          public EnumDeserializer(EnumResolver res)

  - ### Method Detail

    - #### deserializerForCreator

          public static JsonDeserializer<?> deserializerForCreator(DeserializationConfig config,
                                                   Class<?> enumClass,
                                                   AnnotatedMethod factory)

      Factory method used when Enum instances are to be deserialized using a creator (static factory method)
      Returns:
        Deserializer based on given factory method, if type was suitable; null if type can not be used

    - #### isCachable

          public boolean isCachable()

      Because of costs associated with constructing Enum resolvers, let's cache instances by default.
      Overrides:
        `isCachable` in class `JsonDeserializer<Object>`

    - #### deserialize

          public Object deserialize(JsonParser p,
                           DeserializationContext ctxt)
                             throws IOException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

      The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

                {
                    "@class": "class name",
                    ...
                }

      Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

                 if (jp.getCurrentToken() == JsonToken.START_OBJECT) {
                   jp.nextToken();
                 }

      This results in the stream pointing to the field name, so that the two conditions align.

      Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<Object>`
      Parameters:
        `p` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserialized value
      Throws:
        `IOException`

    - #### _deserializeOther

          protected Object _deserializeOther(JsonParser p,
                                 DeserializationContext ctxt)
                                      throws IOException

      Throws:
        `IOException`

    - #### _failOnNumber

          protected void _failOnNumber(DeserializationContext ctxt,
                           JsonParser p,
                           int index)
                                throws IOException

      Throws:
        `IOException`

    - #### _enumClass

          protected Class<?> _enumClass()

Copyright © 2008–2016 FasterXML. All rights reserved.